/* xml.h */

/* Norbert Doerry 
   Version 1
   May 2008


    Copyright (C) 2008 Norbert H. Doerry

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.


    if you find any bugs in this software, please email doerry@aol.com

*/

#define ENTITY_UNKNOWN 0
#define ENTITY_COMMENT 1
#define ENTITY_CDATA   2
#define ENTITY_PI      3
#define ENTITY_DATA    4

#define ERROR_NONE           0
#define ERROR_EOF            1
#define ERROR_SYNTAX         2
#define ERROR_BUFFER_OVERRUN 3
#define ERROR_ENDTAG         4


typedef struct XMLEntity
{
 char *name;  /* name of the Entity */
 char *s;     /* Entity contents */

 int type;     /* entity type */

 struct XMLEntity *child;  /* linked list of child entities */

 struct XMLEntity *Nmtoken;  /* linked list of Name Tokens */
  
 struct XMLEntity *next;  /* link for linked list */ 

 int errflag;
}
XMLENTITY;


void XMLsetDEBUG(void);
void XMLclearDEBUG(void);

XMLENTITY *alloc_XMLENTITY(void);      /* creates the XML Entity */
void free_XMLENTITY(XMLENTITY *);     /* frees an XMLENTITY */

XMLENTITY *readfile_XMLENTITY(FILE *,int *);

XMLENTITY *extract_XMLENTITY(XMLENTITY *,int);

XMLENTITY *extract_XMLENTITY_name(XMLENTITY *, char *);

XMLENTITY *strip_XMLENTITY(XMLENTITY *);

void xmlfprint(FILE *, XMLENTITY *, int );
